#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

char *bitmap[9]={
"t1.xbm",
"t2.xbm",
"t3.xbm",
"t4.xbm",
"t5.xbm",
"t6.xbm",
"t7.xbm",
"t8.xbm",
"t9.xbm"};

#define LARGEBIT 100
#define HOLE	0
#define PERTURBATION 10000

int tab[3][3];

void init()
{
int i,j,n=0;
 for (i=0;i<3;i++)
    for (j=0;j<3;j++)
	{tab[i][j]=n;
	n++;}
}
int casevide(int indice,int *xc,int *yc)
{
int i,j,x,y;
for (i=0;i<3;i++)
    for (j=0;j<3;j++)
	if (tab[i][j]==indice) {x=i;y=j;}
#ifdef DEBUG
fprintf(stderr,"indice %d x %d y %d \n",indice,x,y);
#endif

if (x>0)	{
		if (tab[x-1][y]==HOLE)
		  { *xc=x-1;*yc=y;return (1);}
		}
if (y<2)	{
		if (tab[x][y+1]==HOLE)
		  { *xc=x;*yc=y+1;return (1);}
		}
if (x<2)	{
		if (tab[x+1][y]==HOLE)
		  { *xc=x+1;*yc=y;return (1);}
		}
if (y>0)	{
		if (tab[x][y-1]==HOLE)
		  { *xc=x;*yc=y-1;return (1);}
		}
return (0);
}

void movecase(int indice, int x2,int y2)
{
int temp;
int x,y,i,j;
for (i=0;i<3;i++)
    for (j=0;j<3;j++)
	if (tab[i][j]==indice) {x=i;y=j;}
temp=tab[x][y];
tab[x][y]=tab[x2][y2];
tab[x2][y2]=temp;
printf(".c move %d %d %d\n",indice,(y2-y)*LARGEBIT,(x2-x)*LARGEBIT);
#ifdef DEBUG
fprintf(stderr,"x %d y %d x2 %d y2 %d .c move %d %d %d\n",x,y,x2,y2,indice,(y2-y)*LARGEBIT,(x2-x)*LARGEBIT);
#endif
}

void SetUpTwoWayPipe ( const char *cmd )
 {
    int to_child[2];  /* pipe descriptors from parent->child */
    int to_parent[2]; /* pipe descriptors from child->parent */
   int   pid;
#ifdef DEBUG
   fprintf(stderr,"pipe1\n");
#endif  
   pipe ( to_child );
   pipe ( to_parent ); 

    if ( pid = fork (), pid == 0 )     /* in the child   */
    {
        close ( 0 );                    /* redirect stdin */
        dup ( to_child[0] );
        close ( 1 );                    /* redirect stdout*/
        dup ( to_parent[1] );

        close ( to_child[0] );          /* close pipes    */
        close ( to_child[1] );
        close ( to_parent[0] );
        close ( to_parent[1] );
        fprintf(stderr,"%s execute \n",cmd);
        execlp ( cmd, cmd, NULL );      /* exec the new cmd */
        /*system(cmd);*/
    }
    else if ( pid > 0 )                /* in the parent  */
    {
        close ( 0 );                    /* redirect stdin */
        dup ( to_parent[0] );
        close ( 1 );                    /* redirect stdout  */
        dup ( to_child[1] );

        setbuf ( stdout, NULL );        /* no buffered output */

        close ( to_child[0] );          /* close pipes */
        close ( to_child[1] );
        close ( to_parent[0] );
        close ( to_parent[1] );
    }
    else                                /* error!       */
    {
#ifdef DEBUG
        fprintf ( stderr,"Couldn't fork process %s\n", cmd );
#endif
exit ( 1 );
	}
}
brouille(int *xc,int *yc)
{
int toto,n=0;
while (n<PERTURBATION)
	{n++;
	toto=rand()%9;
	if (casevide(toto,xc,yc)!=0) 
	movecase(toto,*xc,*yc);
	}
}
main()
{
int toto;
/*char toto[100];*/
int i,j,n=0;
int xc,yc;
init();
SetUpTwoWayPipe("wish");
/* tcl-tk source */
printf("canvas .c -width 300 -height 300\n");
printf("pack .c\n"); 
printf("frame .frame\n");
printf("button .frame.r -text restart -command \"puts 255
flush stdout\"\n");
printf("button .frame.b -text quit -command exit\n");
printf("pack .frame\n"); 
printf("pack .frame.r .frame.b  -fill x -side left\n"); 
for (i=0;i<3;i++)
	for (j=0;j<3;j++)
		{
		if (n==0) n++;
		else
		{
		printf(".c create bitmap %d %d -bitmap @%s\n",j*LARGEBIT+LARGEBIT/2,i*LARGEBIT+LARGEBIT/2,bitmap[n]);
		printf(".c bind %d <1> \"puts %d
					 flush stdout\" \n",n,n);
		n++;
		}
		}
n=0;
srand(getpid());
brouille(&xc,&yc);
while(1){
	if (scanf("%d",&toto)==-1) {
#ifdef DEBUG
	fprintf(stderr,"erreur scanf \n");
#endif
	exit(1);}
#ifdef DEBUG
	fprintf(stderr,"%d\n",toto);
#endif
	if (toto==255) brouille(&xc,&yc);
	else
	{
	if (casevide(toto,&xc,&yc)!=0) 
		{movecase(toto,xc,yc);
#ifdef DEBUG
		fprintf(stderr,"trouve %d x:%d y:%d\n",toto,xc,yc);
#endif
		}
	}
	}
}
